#[derive(Copy, Clone, Debug, PartialEq)]
pub struct Position {
    level: u8,
    x: u16,
    y: u16,
}

impl Position {
    pub fn new(level: u8, x: u16, y: u16) -> Self {
        Self {
            level,
            x,
            y,
        }
    }
    pub fn get_level(&self) -> u8 {
        self.level
    }

    pub fn get_x(&self) -> u16 {
        self.x
    }

    pub fn get_y(&self) -> u16 {
        self.y
    }

    pub fn change(&mut self, dx: i8, dy: i8) {
        self.x = ((self.x as i16) + dx as i16) as u16;
        self.y = ((self.y as i16) + dy as i16) as u16;
    }
}